package com.zt.plat.module.qms.business.config.dal.mapper;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardDetailPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardDetailRespVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardDO;
import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardDetailDO;
import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardDetailExtendDO;
import com.zt.plat.module.qms.business.dic.dal.dataobject.DictionaryProjectDO;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 物料检测标准检测项目 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface MaterialAssayStandardDetailMapper extends BaseMapperX<MaterialAssayStandardDetailDO> {

    default PageResult<MaterialAssayStandardDetailDO> selectPage(MaterialAssayStandardDetailPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<MaterialAssayStandardDetailDO>()
                .eqIfPresent(MaterialAssayStandardDetailDO::getMaterialAssayStandardId, reqVO.getMaterialAssayStandardId())
                .eqIfPresent(MaterialAssayStandardDetailDO::getDictionaryProjectId, reqVO.getDictionaryProjectId())
                .eqIfPresent(MaterialAssayStandardDetailDO::getDictionaryProjectCode, reqVO.getDictionaryProjectCode())
                .eqIfPresent(MaterialAssayStandardDetailDO::getUnitId, reqVO.getUnitId())
                .eqIfPresent(MaterialAssayStandardDetailDO::getUnit, reqVO.getUnit())
                .eqIfPresent(MaterialAssayStandardDetailDO::getDataType, reqVO.getDataType())
                .eqIfPresent(MaterialAssayStandardDetailDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(MaterialAssayStandardDetailDO::getAssayCategory, reqVO.getAssayCategory())
                .eqIfPresent(MaterialAssayStandardDetailDO::getIsDefaultPick, reqVO.getIsDefaultPick())
                .eqIfPresent(MaterialAssayStandardDetailDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(MaterialAssayStandardDetailDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(MaterialAssayStandardDetailDO::getRemark, reqVO.getRemark())
                .orderByDesc(MaterialAssayStandardDetailDO::getId));
    }

    List<MaterialAssayStandardDetailExtendDO> selectListWithExtend(@Param("param") MaterialAssayStandardDetailPageReqVO reqVO);

    default List<MaterialAssayStandardDetailRespVO> selectByBaseSampleIds(List<Long> baseSampleIdList) {
    	return selectJoinList(MaterialAssayStandardDetailRespVO.class, new MPJLambdaWrapperX<MaterialAssayStandardDetailDO>()
    			.leftJoin(MaterialAssayStandardDO.class, MaterialAssayStandardDO::getId, MaterialAssayStandardDetailDO::getMaterialAssayStandardId)
    			.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, MaterialAssayStandardDetailDO::getDictionaryProjectId)
    			.selectAll(MaterialAssayStandardDetailDO.class)
    			.selectAs(MaterialAssayStandardDO::getBaseSampleId, MaterialAssayStandardDetailRespVO::getBaseSampleId)
    			.selectAs(DictionaryProjectDO::getName, MaterialAssayStandardDetailRespVO::getDictionaryProjectName)
    			.selectAs(DictionaryProjectDO::getSimpleName, MaterialAssayStandardDetailRespVO::getDictionaryProjectSimpleName)
    			.selectAs(DictionaryProjectDO::getShowName, MaterialAssayStandardDetailRespVO::getDictionaryProjectShowName)
    			.selectAs(DictionaryProjectDO::getCode, MaterialAssayStandardDetailRespVO::getDictionaryProjectCode)
    			.in(MaterialAssayStandardDO::getBaseSampleId, baseSampleIdList)
    			);
    }
    
    default List<MaterialAssayStandardDetailRespVO> selectExtendByIds(List<Long> idList) {
    	return selectJoinList(MaterialAssayStandardDetailRespVO.class, new MPJLambdaWrapperX<MaterialAssayStandardDetailDO>()
    			.leftJoin(MaterialAssayStandardDO.class, MaterialAssayStandardDO::getId, MaterialAssayStandardDetailDO::getMaterialAssayStandardId)
    			.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, MaterialAssayStandardDetailDO::getDictionaryProjectId)
    			.selectAll(MaterialAssayStandardDetailDO.class)
    			.selectAs(MaterialAssayStandardDO::getBaseSampleId, MaterialAssayStandardDetailRespVO::getBaseSampleId)
    			.selectAs(DictionaryProjectDO::getName, MaterialAssayStandardDetailRespVO::getDictionaryProjectName)
    			.selectAs(DictionaryProjectDO::getSimpleName, MaterialAssayStandardDetailRespVO::getDictionaryProjectSimpleName)
    			.selectAs(DictionaryProjectDO::getShowName, MaterialAssayStandardDetailRespVO::getDictionaryProjectShowName)
    			.selectAs(DictionaryProjectDO::getCode, MaterialAssayStandardDetailRespVO::getDictionaryProjectCode)
    			.in(MaterialAssayStandardDetailDO::getId, idList));
    }

}